    001    /*
    002     * Licensed to the Apache Software Foundation (ASF) under one or more
    003     * contributor license agreements.  See the NOTICE file distributed with
    004     * this work for additional information regarding copyright ownership.
    005     * The ASF licenses this file to You under the Apache License, Version 2.0
    006     * (the "License"); you may not use this file except in compliance with
    007     * the License.  You may obtain a copy of the License at
    008     *
    009     *     http://www.apache.org/licenses/LICENSE-2.0
    010     *
    011     * Unless required by applicable law or agreed to in writing, software
    012     * distributed under the License is distributed on an "AS IS" BASIS,
    013     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    014     * See the License for the specific language governing permissions and
    015     * limitations under the License.
    016     */
    017    package org.apache.commons.configuration.beanutils;
    018
    019    /**
    020     * <p>
    021     * Definition of an interface for bean factories.
    022     * </p>
    023     * <p>
    024     * Beans defined in configuration files are not directly created, but by so
    025     * called <em>bean factories</em>. This additional level of indirection
    026     * provides for high flexibility in the creation process. For instance one
    027     * implementation of this interface could be very simple and create a new
    028     * instance of the specified class for each invocation. A different
    029     * implementation could cache already created beans and ensure that always the
    030     * same bean of the given class will be returned - this would be an easy mean
    031     * for creating singleton objects.
    032     * </p>
    033     * <p>
    034     * The interface itself is quite simple. There is a single method for creating a
    035     * bean of a given class. All necessary parameters are obtained from an also
    036     * passed in {@link BeanDeclaration} object. It is also possible
    037     * (but optional) for a bean factory to declare the default class of the bean it
    038     * creates. Then it is not necessary to specify a bean class in the bean
    039     * declaration.
    040     * </p>
    041     *
    042     * @since 1.3
    043     * @author <a
    044     * href="http://commons.apache.org/configuration/team-list.html">Commons
    045     * Configuration team</a>
    046     * @version $Id: BeanFactory.java 1208757 2011-11-30 20:38:15Z oheger $
    047     */
    048    public interface BeanFactory
    049    {
    050        /**
    051         * Returns a bean instance for the given class. The bean will be initialized
    052         * from the specified bean declaration object. It is up to a concrete
    053         * implementation how the bean will be created and initialized.
    054         *
    055         * @param beanClass the class for the bean
    056         * @param data the bean declaration object containing all data about the
    057         * bean to be created
    058         * @param param an additional parameter that may be passed by calling code;
    059         * it is up to a concrete implementation how this parameter is evaluated
    060         * @return the new bean instance (should not be <b>null</b>)
    061         * @throws Exception if an error occurs (the helper classes for creating
    062         * beans will catch this unspecific exception and wrap it in a configuration
    063         * exception)
    064         */
    065        Object createBean(Class<?> beanClass, BeanDeclaration data, Object param)
    066                throws Exception;
    067
    068        /**
    069         * Returns the default bean class of this bean factory. If an implementation
    070         * here returns a non <b>null</b> value, bean declarations using this
    071         * factory do not need to provide the name of the bean class. In such a case
    072         * an instance of the default class will be created.
    073         *
    074         * @return the default class of this factory or <b>null</b> if there is
    075         * none
    076         */
    077        Class<?> getDefaultBeanClass();
    078    }